#declare Clear =
texture {
  pigment { rgbt<1,1,1,1> }
}

#declare Leaves =
texture {
//pigment { rgbt<0,0.1,0,0.8> }
  pigment { rgb<0.1,0.25,0> }
  normal { bumps 0.6 scale 0.3 }
  finish { phong 0.15 }
}

#declare Foliage1 =
blob {
  threshold 0.56
  #declare R = seed(42)
  #declare Count = 0
  #while (Count < 50)
    #declare Angle = rand(R)*75
    #declare Height = 0.4+Angle/750+rand(R)*0.3
    #declare Theta = 360*rand(R)
    #declare Elevation = 0.6-Angle/250+0.1*rand(R)
    sphere { <0,Height,0>, 0.4, 1 rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,Height+0.28,0>, 0.18, 1 rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,0.28,0>, 0.18, 1 rotate 30*x translate Height*y rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,0.28,0>, 0.18, 1 rotate 45*x rotate 120*y translate Height*y rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,0.28,0>, 0.18, 1 rotate 60*x rotate 240*y translate Height*y rotate <Angle,Theta,0> translate Elevation*y }
    #declare Count = Count + 1
  #end
}

#declare Foliage2 =
blob {
  threshold 0.56
  #declare R = seed(72)
  #declare Count = 0
  #while (Count < 50)
    #declare Angle = rand(R)*75
    #declare Height = 0.4+Angle/750+rand(R)*0.3
    #declare Theta = 360*rand(R)
    #declare Elevation = 0.6-Angle/250+0.1*rand(R)
    sphere { <0,Height,0>, 0.4, 1 rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,Height+0.28,0>, 0.18, 1 rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,0.28,0>, 0.18, 1 rotate 30*x translate Height*y rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,0.28,0>, 0.18, 1 rotate 45*x rotate 120*y translate Height*y rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,0.28,0>, 0.18, 1 rotate 60*x rotate 240*y translate Height*y rotate <Angle,Theta,0> translate Elevation*y }
    #declare Count = Count + 1
  #end
}

#declare Foliage3 =
blob {
  threshold 0.56
  #declare R = seed(18)
  #declare Count = 0
  #while (Count < 50)
    #declare Angle = rand(R)*75
    #declare Height = 0.4+Angle/750+rand(R)*0.3
    #declare Theta = 360*rand(R)
    #declare Elevation = 0.6-Angle/250+0.1*rand(R)
    sphere { <0,Height,0>, 0.4, 1 rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,Height+0.28,0>, 0.18, 1 rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,0.28,0>, 0.18, 1 rotate 30*x translate Height*y rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,0.28,0>, 0.18, 1 rotate 45*x rotate 120*y translate Height*y rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,0.28,0>, 0.18, 1 rotate 60*x rotate 240*y translate Height*y rotate <Angle,Theta,0> translate Elevation*y }
    #declare Count = Count + 1
  #end
}

#declare Foliage4 =
blob {
  threshold 0.56
  #declare R = seed(420)
  #declare Count = 0
  #while (Count < 50)
    #declare Angle = rand(R)*75
    #declare Height = 0.4+Angle/750+rand(R)*0.3
    #declare Theta = 360*rand(R)
    #declare Elevation = 0.6-Angle/250+0.1*rand(R)
    sphere { <0,Height,0>, 0.4, 1 rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,Height+0.28,0>, 0.18, 1 rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,0.28,0>, 0.18, 1 rotate 30*x translate Height*y rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,0.28,0>, 0.18, 1 rotate 45*x rotate 120*y translate Height*y rotate <Angle,Theta,0> translate Elevation*y }
    sphere { <0,0.28,0>, 0.18, 1 rotate 60*x rotate 240*y translate Height*y rotate <Angle,Theta,0> translate Elevation*y }
    #declare Count = Count + 1
  #end
}

#declare Tree1 =
union {
  union {
    cone { <0,-0.5,0>, 0.15, <0,1,0>, 0.06 }
    #declare R = seed(42)
    #declare Count = 0
    #while (Count < 50)
      #declare Angle = rand(R)*75
      union {
        #declare Height = 0.4+Angle/750+rand(R)*0.3
        cone { <0,0,0>, 0.05, <0,Height+0.28,0>, 0.002 }
        cone { <0,0,0>, 0.01, <0,0.28,0>, 0.002 rotate 30*x translate Height*y }
        cone { <0,0,0>, 0.01, <0,0.28,0>, 0.002 rotate 45*x rotate 120*y translate Height*y }
        cone { <0,0,0>, 0.01, <0,0.28,0>, 0.002 rotate 60*x rotate 240*y translate Height*y }
        rotate <Angle,360*rand(R),0>
        translate (0.6-Angle/250+0.1*rand(R))*y
      }
      #declare Count = Count + 1
    #end
    #declare Count = 0
    #while (Count < 8)
      cone { <0,-0.5,0>, 0.1 + 0.05*rand(R), <0.2 + 0.2*rand(R),-0.55,0>, 0.05 rotate Count*45*y }
      #declare Count = Count + 1
    #end
    pigment { rgb<0.3,0.2,0.05> }
    normal { bumps 0.8 scale <0.01,0.05,0.01> turbulence 0.05 }
  }
  object { Foliage1
    texture {
      crackle texture_map {
        [0 Clear]
        [0.16 Leaves]
      }
      turbulence 0.6
      scale 0.04
    }
  }
}

#declare Tree2 =
union {
  union {
    cone { <0,-0.5,0>, 0.15, <0,1,0>, 0.06 }
    #declare R = seed(72)
    #declare Count = 0
    #while (Count < 50)
      #declare Angle = rand(R)*75
      union {
        #declare Height = 0.4+Angle/750+rand(R)*0.3
        cone { <0,0,0>, 0.05, <0,Height+0.28,0>, 0.002 }
        cone { <0,0,0>, 0.01, <0,0.28,0>, 0.002 rotate 30*x translate Height*y }
        cone { <0,0,0>, 0.01, <0,0.28,0>, 0.002 rotate 45*x rotate 120*y translate Height*y }
        cone { <0,0,0>, 0.01, <0,0.28,0>, 0.002 rotate 60*x rotate 240*y translate Height*y }
        rotate <Angle,360*rand(R),0>
        translate (0.6-Angle/250+0.1*rand(R))*y
      }
      #declare Count = Count + 1
    #end
    #declare Count = 0
    #while (Count < 6)
      cone { <0,-0.5,0>, 0.1 + 0.05*rand(R), <0.2 + 0.2*rand(R),-0.55,0>, 0.05 rotate Count*60*y }
      #declare Count = Count + 1
    #end
    pigment { rgb<0.3,0.2,0.05> }
    normal { bumps 0.8 scale <0.01,0.05,0.01> turbulence 0.05 }
  }
  object { Foliage2
    texture {
      crackle texture_map {
        [0 Clear]
        [0.16 Leaves]
      }
      turbulence 0.6
      scale 0.04
    }
  }
}

#declare Tree3 =
union {
  union {
    cone { <0,-0.5,0>, 0.15, <0,1,0>, 0.06 }
    #declare R = seed(18)
    #declare Count = 0
    #while (Count < 50)
      #declare Angle = rand(R)*75
      union {
        #declare Height = 0.4+Angle/750+rand(R)*0.3
        cone { <0,0,0>, 0.05, <0,Height+0.28,0>, 0.002 }
        cone { <0,0,0>, 0.01, <0,0.28,0>, 0.002 rotate 30*x translate Height*y }
        cone { <0,0,0>, 0.01, <0,0.28,0>, 0.002 rotate 45*x rotate 120*y translate Height*y }
        cone { <0,0,0>, 0.01, <0,0.28,0>, 0.002 rotate 60*x rotate 240*y translate Height*y }
        rotate <Angle,360*rand(R),0>
        translate (0.6-Angle/250+0.1*rand(R))*y
      }
      #declare Count = Count + 1
    #end
    #declare Count = 0
    #while (Count < 4)
      cone { <0,-0.5,0>, 0.1 + 0.05*rand(R), <0.2 + 0.2*rand(R),-0.55,0>, 0.05 rotate Count*90*y }
      #declare Count = Count + 1
    #end
    pigment { rgb<0.3,0.2,0.05> }
    normal { bumps 0.8 scale <0.01,0.05,0.01> turbulence 0.05 }
  }
  object { Foliage3
    texture {
      crackle texture_map {
        [0 Clear]
        [0.16 Leaves]
      }
      turbulence 0.6
      scale 0.04
    }
  }
}

#declare Tree4 =
union {
  union {
    cone { <0,-0.5,0>, 0.15, <0,1,0>, 0.06 }
    #declare R = seed(420)
    #declare Count = 0
    #while (Count < 50)
      #declare Angle = rand(R)*75
      #declare Height = 0.4+Angle/750+rand(R)*0.3
      union {
        cone { <0,0,0>, 0.05, <0,Height+0.28,0>, 0.002 }
        cone { <0,0,0>, 0.01, <0,0.28,0>, 0.002 rotate 30*x translate Height*y }
        cone { <0,0,0>, 0.01, <0,0.28,0>, 0.002 rotate 45*x rotate 120*y translate Height*y }
        cone { <0,0,0>, 0.01, <0,0.28,0>, 0.002 rotate 60*x rotate 240*y translate Height*y }
        rotate <Angle,360*rand(R),0>
        translate (0.6-Angle/250+0.1*rand(R))*y
      }
      #declare Count = Count + 1
    #end
    #declare Count = 0
    #while (Count < 3)
      cone { <0,-0.5,0>, 0.1 + 0.05*rand(R), <0.2 + 0.2*rand(R),-0.55,0>, 0.05 rotate Count*120*y }
      #declare Count = Count + 1
    #end
    pigment { rgb<0.3,0.2,0.05> }
    normal { bumps 0.8 scale <0.01,0.05,0.01> turbulence 0.05 }
  }
  object { Foliage4
    texture {
      crackle texture_map {
        [0 Clear]
        [0.16 Leaves]
      }
      turbulence 0.6
      scale 0.04
    }
  }
}
